#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "xpu2context4xi.py">
#<abstract4xi abstract = "XPU context management"/>
#<refer4xi reference = "context4xi.py"/>
#<verify4xi verification = "10" target = "xpu2event4xi.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'XPU2Context4Xi',
            'create2context4xpu',
            'get2context4xpu',
            'release2context4xpu',
            'retain2context4xpu',
            'set2context4xpu',
            'trace2context4xpu'] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   

from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi

from platformids4xi import get2platformids4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global xpu2context4xi                                                   # Context of XPU

global xpu2trace4xi                                                     # TRACE

global fetch2code4xpu                                                   # Fetched code

global import2use4xpu                                                   # Imports of target function for Process4Xi

global kb2fetch4xpu                                                     # Knowledgebase for fetching
global kb2kernel4xpu                                                    # Knowledgebase for kernel   

global folder2lib4xpu                                                   # Folder of XPU library

global profile2fetch                                                       # Profile knowledgebase for fetching
global keys2profile4xpu

global target2function4xpu                                              # Target function for Process4Xi
      
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>
# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2context4xpu" usage = "
#
#   task4create2xpu = {}                                                                                            
#   task4create2xpu= {}      
#   task4create2xpu['FUNCTION2CALLBACK'] = trace2context4xpu                                                   # CALLBACK FUNCTION CALLED BY XPUIZED OPENCL
# 
#   args2callback = {}                                                                                                          
#   args2callback['CLASS']   = "create2context4xpu"                                                               # MODULE OF XPUIZED OPENCL MODULE
#   args2callback['METHOD']  = "create2context4xpu"                                                               # FUNCTION OF XPUIZED OPENCL MODULE
#   args2callback['MESSAGE'] = "{(Step 2Z1/33) failed" + "; create2context4xpu-failed " + "; time: " + time4xi() + "}"          # ERROR MESSAGE FOR XPUIZED OPENCL TO RETURN    
#   
#   task4create2xpu['ARGS2CALLBACK'] = args2callback                                                              # MAX ONE ARG - THEREFORE GIVE SEVERAL ARGS IN ONE DICTIONARY 
#   
#   response4create2context = {}
#   print('(Step 1A/33) OF CONTEXT4XI5TEST - TRYING TO CREATE CONTEXT FOR XPU ', time4xi())  
#   try:                               
#       response4create2context = create2context4xpu (task4create2context)                                        # EXAMINE RESPONSE!                                                      
#       print('(Step 1B/33) OF CONTEXT4XI5TEST - RESPONSE4CREATE2CONTEXT : ', response4create2context)               # trace2context4xpu CALLED BY XPUIZED OPENCL IN EXCEPTIONS - CHECK XPUIZED TRACE!                       
#   except: 
#       print('(Step Z1/33) OF CONTEXT4XI5TEST *** FAILED TO CREARE CONTEXT FOR XPU ', time4xi())  
#
#">

# -------------------------------------------------------------------------------------------------   
def trace2context4xpu(task4trace2xpu=None):

    '''
    creates xpu2context4xi
    '''
    
    global xpu2trace4xi 
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2context4xpu" 
    method2print = "trace2context4xpu"

    message2print = "{(Step 1A/33) started" + "; trace2context4xpu-started: " + str(trace2context4xpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # <function trace2context4xpu at 0x00000000031898C8>  
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2xpu-to-trace2context4xpu: " + str(task4trace2xpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4xpu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}', 
    #    'CLASS': 'get2context4xpu', 
    #   'METHOD': 'get2context4xpu'}; time: 22:50:59 05/11/11 Pacific Daylight Time}

    code2ack  = ' '
    code2nack = ' '    
    
    xpu2trace4xi = {}                                                                                            # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2xpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY XPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2xpu = {}                                                                                            
            
        task4trace2xpu= {} 
  
        message2print = "{(Step 2A/33) warned" + "; task4trace2xpu-warned-by-trace2context4xpu to: " + str(task4trace2xpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
            
        code2nack = code2nack + '2A-'            

    else:
        # -----------------------------------------------------------------------------------------
        # PARAMETER GIVEN BY XPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------          
        message2print = "{(Step 3A/33) try" + "; task4trace2xpu-try-by-trace2context4xpu: " + str(task4trace2xpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4xpu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}', 
        #    'CLASS': 'get2context4xpu', 
        #   'METHOD': 'get2context4xpu'}; time: 22:50:59 05/11/11 Pacific Daylight Time}

        try:
            class2print   = task4trace2xpu['CLASS']                                                              # XPUIZE XPU TRACE!
            method2print  = task4trace2xpu['METHOD']
            message2print = task4trace2xpu['MESSAGE']
            print4xi(class2print, method2print, message2print)                                                      # XPUIZED TRACE FOR OPENCL CALLBACK!
            # =================================
            # { get2context4xpu : get2context4xpu ; (Step 6Z1/33) failed; get2context4xpu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}
            # =================================
            
            class2print = "trace2context4xpu"                                                                    # SET TRACE BACK TO THIS FUNCTION!
            method2print = "trace2context4xpu"                
            message2print = "{(Step 3B/33) performed" + "; xpu-trace-performed-by-trace2context4xpu: " + str(task4trace2xpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # xpu-trace-performed-by-trace2context4xpu: 
            # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4xpu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'get2context4xpu', 
            #   'METHOD': 'get2context4xpu'}; time: 22:50:59 05/11/11 Pacific Daylight Time}

            code2ack = code2ack + '3B-' 
        except:
            message2print = "{(Step 3Z1/33) failed" + "; xpu-trace-failed-by-trace2context4xpu: " + str(task4trace2xpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
            code2nack = code2nack + '3Z1-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; trace2context4xpu-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    # trace2context4xpu-returning: 22:50:59 05/11/11 Pacific Daylight Time
    
    return
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2context4xpu" usage = "
#     
#   context4xi = {}        
#   try:
#       context4xi['XPU'] = create2context4xpu()                                                            # XPU context      
#       message2print = "{(Step 2B/33) initialized" + "; xpu-context4xi-initialized-by-create2context4xi to: " + str(context4xi)  + "; time: " + time4xi() + "}" 
#       print4xi(class2print, method2print, message2print)     
#       ....                                                                                                      # context of devices
#   except:
#       message2print = "{(Step 3Z1/33) yielded" + "; context4xi-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print)                                                              
#
#">

# -------------------------------------------------------------------------------------------------   
def create2context4xpu(task4create2xpu=None):

    '''
    creates xpu2context4xi
    '''
    
    global xpu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2context4xpu" 
    method2print = "create2context4xpu"

    message2print = "{(Step 1A/70) started" + "; create2context4xpu-started: " + str(create2context4xpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2context4xpu at 0x000000000339E948> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2xpu-to-create2context4xpu: " + str(task4create2xpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None 

    code2ack  = ' '
    code2nack = ' '    
    
    xpu2context4xi = {}                                                                                          # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4create2xpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - CREATE TASK CONTEXT
            # -----------------------------------------------------------------------------------------    
            task4create2xpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4create2xpu-initialized-by-create2context4xpu to: " + str(task4create2xpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            
            function2callback4xpu = trace2context4xpu                                                         # CALLBACK FUNCTION FOR XPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4xpu-initialized-by-create2context4xpu to: " + str(function2callback4xpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2context4xpu at 0x000000000339E8C8>
            code2ack  = code2ack + '2A-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2context4xpu"                                                      # MODULE OF XPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2context4xpu"                                                      # FUNCTION OF XPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2context4xpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR XPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-initialized-by-create2context4xpu to: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2context4xpu-failed ; time: 20:18:34 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'create2context4xpu', 
            #   'METHOD': 'create2context4xpu'}; time: 20:18:34 05/11/11 Pacific Daylight Time}

              
            task4create2xpu['DATA2CALLBACK'] = args2callback                                                     # USER DATA PASSED TO XPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4create2xpu['FUNCTION2CALLBACK'] = function2callback4xpu                                      # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) set" + "; task4create2xpu-initialized-by-create2context4xpu to: " + str(task4create2xpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {  'XPU': {'FUNCTION2CALLBACK': <function trace2context4xpu at 0x00000000031898C8>,
            #    'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4xpu-failed ; time: 20:43:04 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'create2context4xpu', 'METHOD': 'create2context4xpu'}}}; time: 20:43:04 05/11/11 Pacific Daylight Time}

            
            platform2xi = {}
            message2print = "{(Step 1G/70) initialized" + "; platform2xi-initialized-by-create2context4xpu to: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # {}
            try:
                platform2xi = get2platformids4xi()
                message2print = "{(Step 1H/70) got" + "; platform2xi-got-by-create2context4xpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'available2platform': 1, 'max2entries': 1}
                code2ack  = code2ack + '2D-'
            except:
                message2print = "{(Step 1Z1/70) failed" + "; platform2xi-failed-by-create2context4xpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                         #
                 
            task4create2xpu['PLATFORM'] = platform2xi                                                             # PLATFORM OF SYSTEM   
            task4create2xpu['PROPERTIES'] = None                                                                  # CONTEXT PROPERTIES
            task4create2xpu['INFO2PRIVATE'] = None                                                                # USED TO DEDUCE POINTER TO PRIVATE BINARY ERROR RETURNED BY OPENCL 
            task4create2xpu['SIZE2PRIVATE'] = 0                                                                   # USED TO DEDUCE POINTER TO SIZE OF PRIVATE BINARY ERROR RETURNED BY OPENCL 
            
            task4create2xpu ['COUNT2REFERENCE'] = 0                                                               # USED TO RETAIN(ATTACH) AND RELEASE CONTEXT 
              
            message2print = "{(Step 1I/70) created" + "; task4create2xpu-initialized-by-create2context4xpu to: " + str(task4create2xpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {  'XPU': {'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4xpu-failed ; time: 20:43:04 05/11/11 Pacific Daylight Time}', 
            #            'CLASS': 'create2context4xpu', 'METHOD': 'create2context4xpu'}, 'FUNCTION2CALLBACK': <function trace2context4xpu at 0x00000000031898C8>, 
            #            'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
            #            'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 20:43:04 05/11/11 Pacific Daylight Time}

                        
            code2ack  = code2ack + '2E-'
            
                         
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4create2xpu-yielded-by-create2context4xpu: " + str(task4create2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '1Z2-' 

    xpu2context4xi = {}                                                                                          # INITIALIZE XPU CONTEXT                                                                                      

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4create2xpu.keys()        
    message2print = "{(Step 8/70) using" + "; keys2task-using-by-create2context4xpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 

    if 'PLATFORM' in keys2task:
        message2print = "{(Step 2A/70) try" + "; platform-try-by-create2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # {}
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 2/70) - PLATFORM
            # -----------------------------------------------------------------------------------------               
            xpu2context4xi['PLATFORM'] = task4create2xpu['PLATFORM']
            
            message2print = "{(Step 2B/70) initialized" + "; platform-initialized-by-create2context4xpu to: " + str(xpu2context4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 20:55:51 05/11/11 Pacific Daylight Time}
            code2ack  = code2ack + '2B-'
        except: 
            message2print = "{(Step 2Z1/70) yielded" + "; platform-xpu2context4xi-yielded-by-create2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z1-' 

    if 'PROPERTIES' in keys2task:            
        message2print = "{(Step 3A/70) try" + "; properties-try-by-create2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/70) - PROPERTIES
            # -----------------------------------------------------------------------------------------               
            xpu2context4xi['PROPERTIES'] = task4create2xpu['PROPERTIES']
            
            message2print = "{(Step 3B/70) initialized" + "; properties-initialized-by-create2context4xpu to: " + str(xpu2context4xi['PROPERTIES'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # None
            code2ack  = code2ack + '3B-'
        except: 
            message2print = "{(Step 3Z1/70) yielded" + "; properties-xpu2context4xi-yielded-by-create2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '3Z1-' 

    if 'DATA2CALLBACK' in keys2task:        
        message2print = "{(Step 4A/70) try" + "; data2callback-try-by-create2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 4/70) - DATA2CALLBACK 
            # -----------------------------------------------------------------------------------------               
            xpu2context4xi['DATA2CALLBACK'] = task4create2xpu['DATA2CALLBACK']
            
            message2print = "{(Step 4B/70) initialized" + "; data2callback-initialized-by-create2context4xpu to: " + str(xpu2context4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2context4xpu-failed ; time: 20:55:51 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'create2context4xpu', 
            #   'METHOD': 'create2context4xpu'}; time: 20:55:51 05/11/11 Pacific Daylight Time}
    
            code2ack  = code2ack + '4B-'
        except: 
            message2print = "{(Step 4Z1/70) yielded" + "; data2callback-xpu2context4xi-yielded-by-create2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z1-'

    if 'INFO2PRIVATE' in keys2task:         
        message2print = "{(Step 5A/70) try" + "; info2private-try-by-create2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 5/70) - INFO2PRIVATE
            # -----------------------------------------------------------------------------------------               
            xpu2context4xi['INFO2PRIVATE'] = task4create2xpu['INFO2PRIVATE']
            
            message2print = "{(Step 5B/70) initialized" + "; info2private-initialized-by-create2context4xpu to: " + str(xpu2context4xi['INFO2PRIVATE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # None
            code2ack  = code2ack + '5B-'
        except: 
            message2print = "{(Step 5Z1/70) yielded" + "; info2private-xpu2context4xi-yielded-by-create2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '5Z1-'         

    if 'SIZE2PRIVATE' in keys2task:    
        message2print = "{(Step 6A/70) try" + "; size2private-try-by-create2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 6/70) - SIZE2PRIVATE
            # -----------------------------------------------------------------------------------------               
            xpu2context4xi['SIZE2PRIVATE'] = task4create2xpu['SIZE2PRIVATE']
            
            message2print = "{(Step 6B/70) initialized" + "; size2private-initialized-by-create2context4xpu to: " + str(xpu2context4xi['SIZE2PRIVATE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            code2ack  = code2ack + '6B-'
        except: 
            message2print = "{(Step 6Z1/70) yielded" + "; size2private-xpu2context4xi-yielded-by-create2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '6Z1-'

    if 'FUNCTION2CALLBACK' in keys2task:        
        message2print = "{(Step 7A/70) try" + "; function2callback-try-by-create2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 7/70) - FUNCTION2CALLBACK
            # -----------------------------------------------------------------------------------------               
            xpu2context4xi['FUNCTION2CALLBACK'] = task4create2xpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 7B/70) initialized" + "; function2callback-initialized-by-create2context4xpu to: " + str(xpu2context4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2context4xpu at 0x00000000032098C8>
            code2ack  = code2ack + '7B-'
        except: 
            message2print = "{(Step 7Z1/70) yielded" + "; function2callback-xpu2context4xi-yielded-by-create2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z1-'


    if 'COUNT2REFERENCE' in keys2task:        
        message2print = "{(Step 8A/70) try" + "; count2reference-try-by-create2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 8/70) - COUNT2REFERENCE
            # -----------------------------------------------------------------------------------------               
            xpu2context4xi['COUNT2REFERENCE'] = task4create2xpu['COUNT2REFERENCE']
            
            message2print = "{(Step 8B/70) initialized" + "; count2reference-initialized-by-create2context4xpu to: " + str(xpu2context4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '7B-'
        except: 
            message2print = "{(Step 8Z1/70) yielded" + "; count2reference-xpu2context4xi-yielded-by-create2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z1-'        
                                                 
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    xpu2context4xi ['ACK2RETURN']  = code2ack
    xpu2context4xi ['NACK2RETURN'] = code2nack
    
    message2print = "{(Step 70/70) returning" + "; xpu2context4xi-returning-by-create2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4xpu-failed ; time: 20:55:51 05/11/11 Pacific Daylight Time}', 
    #          'CLASS': 'create2context4xpu', 'METHOD': 'create2context4xpu'}, 
    #  'FUNCTION2CALLBACK': <function trace2context4xpu at 0x00000000032098C8>, 
    #         'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B', 
    #       'INFO2PRIVATE': None, 
    #           'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #        'NACK2RETURN': ' ', 
    #       'SIZE2PRIVATE': 0, 
    #         'PROPERTIES': None
    # }; time: 20:55:51 05/11/11 Pacific Daylight Time}
 

    
    return xpu2context4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2context4xpu" usage = "
#
#   # Example (from context4xi.py - task4set2context got as parameter - see context4xi5test.py)
#
#   if context4xi is None:
#       context4xi = create2context4xi()                                                                          # CREATE CONTEXT4XI
#   try:
#       # -----------------------------------------------------------------------------
#       # (Step 4A/33)
#       # ----------------------------------------------------------------------------- 
#       message2print = "{(Step 4A/33) passing" + "; task-passing-to-set2context4xpu: " + str(task4set2context['XPU'])  + "; time: " + time4xi() + "}"  
#       print4xi(class2print, method2print, message2print)                                                         
#          
#       context4xi ['XPU'] = set2context4xpu(task4set2context['XPU'])                                        # 
#            
#       message2print = "{(Step 4B/33) set" + "; xpu-context-set-by-set2context4xpu to: " + str(context4xi ['XPU'])  + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print)                                                          
#       code2ack  = code2ack + '4B-'
#   except:
#       message2print = "{(Step 4Z1/33) yielded" + "; xpu-yielded-by-set2context4xi: " + 'XPU' + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print) 
#       code2nack  = code2nack + '4Z1-'
#">

# -------------------------------------------------------------------------------------------------   
def set2context4xpu(task4set2xpu=None):

    '''
    sets xpu2context4xi
    '''
    global xpu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2context4xpu"
    method2print = "set2context4xpu"

    message2print = "{(Step 1A/33) started" + "; set2context4xpu-started: " + str(set2context4xpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2context4xpu at 0x000000000331CD48>
    
    message2print = "{(Step 1B/33) passed" + "; task4set2xpu-to-set2context4xpu: " + str(task4set2xpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4xpu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 'CLASS': 'get2context4xpu', 'METHOD': 'get2context4xi4xpu'}, 
    #  'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4xpu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 'CLASS': 'get2context4xpu', 'METHOD': 'get2context4xi4xpu'}, 
    #  'FUNCTION2CALLBACK': <function trace2context4xpu at 0x000000000331CC48>, 'INFO2PRIVATE': None, 
    #           'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #       'SIZE2PRIVATE': 0, 
    #         'PROPERTIES': None
    #}; time: 23:20:05 05/11/11 Pacific Daylight Time}

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if xpu2context4xi is None:
            xpu2context4xi = create2context4xpu()                                                             # INITIALIZE CONTEXT FOR XPU                      
    except:
        try:
            xpu2context4xi = create2context4xpu()
        except:
            xpu2context4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; xpu2context4xi-yielded-by-set2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 2A/70) try" + "; platform-try-by-set2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 2/70) - PLATFORM (DIRECT TRANSFER FROM INPUT TRIED - AS WITH OTHERS)
        # -----------------------------------------------------------------------------------------               
        xpu2context4xi['PLATFORM'] = task4set2xpu['PLATFORM']
        
        message2print = "{(Step 2B/70) set" + "; platform-set-by-set2context4xpu to: " + str(xpu2context4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 23:20:05 05/11/11 Pacific Daylight Time}

        code2ack  = code2ack + '2B-'
    except: 
        message2print = "{(Step 2Z1/70) yielded" + "; platform-xpu2context4xi-yielded-by-set2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '2Z1-' 
        
    message2print = "{(Step 3A/70) try" + "; properties-try-by-set2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 3/70) - PROPERTIES
        # -----------------------------------------------------------------------------------------               
        xpu2context4xi['PROPERTIES'] = task4set2xpu['PROPERTIES']
        
        message2print = "{(Step 3B/70) set" + "; properties-set-by-set2context4xpu to: " + str(xpu2context4xi['PROPERTIES'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # None
        code2ack  = code2ack + '3B-'
    except: 
        message2print = "{(Step 3Z1/70) yielded" + "; properties-xpu2context4xi-yielded-by-set2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '3Z1-' 
        
    message2print = "{(Step 4A/70) try" + "; data2callback-try-by-set2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 4/70) - DATA2CALLBACK
        # -----------------------------------------------------------------------------------------               
        xpu2context4xi['DATA2CALLBACK'] = task4set2xpu['DATA2CALLBACK']
        
        message2print = "{(Step 4B/70) set" + "; data2callback-set-by-set2context4xpu to: " + str(xpu2context4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4xpu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 
        #    'CLASS': 'get2context4xpu', 
        #   'METHOD': 'get2context4xi4xpu'}; time: 23:20:05 05/11/11 Pacific Daylight Time}

        code2ack  = code2ack + '4B-'
    except: 
        message2print = "{(Step 4Z1/70) yielded" + "; data2callback-xpu2context4xi-yielded-by-set2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '4Z1-'
         
    message2print = "{(Step 5A/70) try" + "; info2private-try-by-set2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 5/70) - INFO2PRIVATE
        # -----------------------------------------------------------------------------------------               
        xpu2context4xi['INFO2PRIVATE'] = task4set2xpu['INFO2PRIVATE']
        
        message2print = "{(Step 5B/70) set" + "; info2private-set-by-set2context4xpu to: " + str(xpu2context4xi['INFO2PRIVATE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # None
        code2ack  = code2ack + '5B-'
    except: 
        message2print = "{(Step 5Z1/70) yielded" + "; info2private-xpu2context4xi-yielded-by-set2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '5Z1-'         
    
    message2print = "{(Step 6A/70) try" + "; size2private-try-by-set2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)           
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 6/70) - SIZE2PRIVATE
        # -----------------------------------------------------------------------------------------               
        xpu2context4xi['SIZE2PRIVATE'] = task4set2xpu['SIZE2PRIVATE']
        
        message2print = "{(Step 6B/70) set" + "; size2private-set-by-set2context4xpu to: " + str(xpu2context4xi['SIZE2PRIVATE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
        code2ack  = code2ack + '6B-'
    except: 
        message2print = "{(Step 6Z1/70) yielded" + "; size2private-xpu2context4xi-yielded-by-set2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '6Z1-'
        
    message2print = "{(Step 7A/70) try" + "; function2callback-try-by-set2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    # {'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4xpu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 'CLASS': 'get2context4xpu', 'METHOD': 'get2context4xi4xpu'}, 'FUNCTION2CALLBACK': <function trace2context4xpu at 0x000000000331CC48>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 23:20:05 05/11/11 Pacific Daylight Time}

    try:
        # -----------------------------------------------------------------------------------------
        # (Step 7/70) - FUNCTION2CALLBACK
        # -----------------------------------------------------------------------------------------               
        xpu2context4xi['FUNCTION2CALLBACK'] = task4set2xpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 7B/70) set" + "; function2callback-set-by-set2context4xpu to: " + str(xpu2context4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # <function trace2context4xpu at 0x000000000331CC48>
        code2ack  = code2ack + '7B-'
    except: 
        message2print = "{(Step 7Z1/70) yielded" + "; function2callback-xpu2context4xi-yielded-by-set2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '7Z1-'


    try:
        # -----------------------------------------------------------------------------------------
        # (Step 8/70) - COUNT2REFERENCE
        # -----------------------------------------------------------------------------------------               
        xpu2context4xi['COUNT2REFERENCE'] = task4set2xpu['COUNT2REFERENCE']
        
        message2print = "{(Step 8B/70) set" + "; count2reference-set-by-set2context4xpu to: " + str(xpu2context4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '8B-'
    except: 
        message2print = "{(Step 8Z1/70) yielded" + "; count2reference-xpu2context4xi-yielded-by-set2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '8Z1-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    xpu2context4xi ['ACK2RETURN']  = code2ack
    xpu2context4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; xpu2context4xi-returning-by-set2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # xpu2context4xi-returning-by-set2context4xpu: 
    #  {'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4xpu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 
    #                       'CLASS': 'get2context4xpu', 
    #                      'METHOD': 'get2context4xi4xpu'}, 
    #   'FUNCTION2CALLBACK': <function trace2context4xpu at 0x000000000331CC48>, 
    #          'ACK2RETURN': ' 2B3B4B5B6B7B', 
    #        'INFO2PRIVATE': None, 
    #            'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #         'NACK2RETURN': ' ', 
    #        'SIZE2PRIVATE': 0, 
    #          'PROPERTIES': None
    # }; time: 23:20:05 05/11/11 Pacific Daylight Time}

    return xpu2context4xi

            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2context4xpu" usage = "
#
#   # Example (see context4xi5test.py)
#   # (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RELEASED BY DECRENTING COUNT WITH 1             
#   task4release2context = {}
#   task4release2context ['XPU'] = {} 
#    
#   task4release2context ['XPU'] ['COUNT2REFERENCE'] = 1                                                            # REFERENCE COUNT
#   response4release2context = {}
#   
#   print('(Step 5A/33) OF CONTEXT4XI5TEST - TRYING TO RELEASE CONTEXT OF XPU DEVICE ', time4xi())  
#   try:                               
#       response4release2context = release2context4xi(task4release2context)                                         # COUNT2REFERENCE                                                      
#       print('(Step 5BD/33) OF CONTEXT4XI5TEST - RESPONSE4RELEASE2CONTEXT : ', response4release2context)                          
#       
#   except:
#       print('(Step 5Z1/33) OF CONTEXT4XI5TEST *** FAILED TO RELEASE CONTEXT OF XPU DEVICE ', time4xi())  
#">

# -------------------------------------------------------------------------------------------------   
def release2context4xpu(task4release2xpu=None):

    '''
    releases xpu2context4xi
    '''
    global xpu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2context4xpu"
    method2print = "release2context4xpu" 

    message2print = "{(Step 1A/33) started" + "; release2context4xpu-started: " + str(release2context4xpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function release2context4xpu at 0x0000000003361348> 
    
    message2print = "{(Step 1B/33) passed" + "; task4release2xpu-to-release2context4xpu: " + str(task4release2xpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1}

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if xpu2context4xi is None:
            xpu2context4xi = create2context4xpu()                                                             # INITIALIZE CONTEXT                 
    except:
        try:
            xpu2context4xi = create2context4xpu()
        except:
            xpu2context4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; xpu2context4xi-yielded-by-release2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2xpu is None:
        task4release2xpu = {}
        task4release2xpu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        xpu2context4xi['COUNT2REFERENCE'] = xpu2context4xi['COUNT2REFERENCE'] - task4release2xpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2context4xpu: " + str(xpu2context4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
         
        if xpu2context4xi['COUNT2REFERENCE'] < 0:
            xpu2context4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2context4xpu: " + " ** " + str(xpu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
                
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            xpu2context4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2context4xpu: " + " ** " + str(xpu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; xpu2context4xi-yielded-by-release2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    xpu2context4xi ['ACK2RETURN']  = code2ack
    xpu2context4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; xpu2context4xi-returning-by-release2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4xpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4xpu', 'METHOD': 'get2context4xi4xpu'}, 'FUNCTION2CALLBACK': <function trace2context4xpu at 0x00000000033611C8>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:03:17 05/15/11 Pacific Daylight Time}
 
    
    return xpu2context4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2context4xpu" usage = "
#
#   # Example (see context4xi5test.py)
#   # (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAIND BY INCREMENTING COUNT WITH 1             
#   task4retain2context = {}
#   task4retain2context ['XPU'] = {} 
#    
#   task4retain2context ['XPU'] ['COUNT2REFERENCE'] = 1                  # ADD REFERENCE COUNT BY 1
#   response4retain2context = {}
#   
#   print('(Step 5A/33) OF CONTEXT4XI5TEST - TRYING TO RETAIN CONTEXT OF XPU DEVICE ', time4xi())  
#   try:                               
#       response4retain2context = retain2context4xi(task4retain2context)                                                                                          
#       print('(Step 5BD/33) OF CONTEXT4XI5TEST - RESPONSE4RETAIN2CONTEXT : ', response4retain2context)                          
#       
#   except:
#       print('(Step 5Z1/33) OF CONTEXT4XI5TEST *** FAILED TO RETAIN CONTEXT OF XPU DEVICE ', time4xi())  
#">

# -------------------------------------------------------------------------------------------------   
def retain2context4xpu(task4retain2xpu=None):

    '''
    retains xpu2context4xi
    '''
    global xpu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2context4xpu"
    method2print = "retain2context4xpu"

    message2print = "{(Step 1A/33) started" + "; retain2context4xpu-started: " + str(retain2context4xpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2xpu-to-retain2context4xpu: " + str(task4retain2xpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if xpu2context4xi is None:
            xpu2context4xi = create2context4xpu()                                                             # INITIALIZE CONTEXT                 
    except:
        try:
            xpu2context4xi = create2context4xpu()
        except:
            xpu2context4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; xpu2context4xi-yielded-by-retain2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; retain-try-by-retain2context4xpu: " + str(xpu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
           
    try:
        # -----------------------------------------------------------------------------------------
        # RETAIN
        # -----------------------------------------------------------------------------------------               
        xpu2context4xi['COUNT2REFERENCE'] = xpu2context4xi['COUNT2REFERENCE'] + task4retain2xpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1C/70) calculated" + "; count2reference-calculated-by-retain2context4xpu: " + str(xpu2context4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #
         
        if xpu2context4xi['COUNT2REFERENCE'] <= 0:
            xpu2context4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1D/70) warning" + "; count2reference-warning-by-retain2context4xpu: " + " ** " + str(xpu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
                
            code2nack  = code2nack + '1D-'
        else:
            code2ack  = code2ack + '1D-'
    except:
        try:
            xpu2context4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1Z1/70) warning" + "; count2reference-warning-by-retain2context4xpu: " + " ** " + str(xpu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '1Z1-'
            
        except:
            message2print = "{(Step 1Z2/70) yielded" + "; xpu2context4xi-yielded-by-retain2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    xpu2context4xi ['ACK2RETURN']  = code2ack
    xpu2context4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; xpu2context4xi-returning-by-retain2context4xpu: " + str(xpu2context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    #  {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4xpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4xpu', 'METHOD': 'get2context4xi4xpu'}, 'FUNCTION2CALLBACK': <function trace2context4xpu at 0x00000000033611C8>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:03:17 05/15/11 Pacific Daylight Time}

    
    return xpu2context4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2context4xpu" usage = "
#
#   try:                               
#       response4get2xpu = get2context4xpu()                                        
#                                                                                                                   
#   except:
#       ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def get2context4xpu():

    '''
    gets xpu2context4xi
    '''
    
    global xpu2context4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2context4xpu"
    method2print = "get2context4xpu"

    message2print = "{(Step 1A/33) started" + "; get2context4xpu-started: " + str(get2context4xpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function get2context4xpu at 0x000000000323E048>                                                              
    try: 
        if xpu2context4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            xpu2xi = create2context4xpu()
            message2print = "{(Step 1B/33) initialized" + "; xpu2xi-initialized-by-get2context4xpu to: " + str(xpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
        else:
            # -------------------------------------------------------------------------------------
            # RETURN THE EXISTING CONTEXT FOR XPU          
            # -------------------------------------------------------------------------------------     
            xpu2xi = xpu2context4xi
            message2print = "{(Step 1C/33) got" + "; xpu2xi-got-by-get2context4xpu: " + str(xpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            xpu2xi = create2context4xpu()
            
            message2print = "{(Step 1D/33) initialized" + "; xpu2xi-initialized-by-get2context4xpu to: " + str(xpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4xpu-failed ; time: 08:44:09 05/19/11 Pacific Daylight Time}', 
            #             'CLASS': 'create2context4xpu', 'METHOD': 'create2context4xpu'}, 
            # 'FUNCTION2CALLBACK': <function trace2context4xpu at 0x0000000003230D48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 
            # 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
            # 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 08:44:09 05/19/11 Pacific Daylight Time}
               
            
        except:
            xpu2xi = {}            
            message2print = "{(Step 1Z2/70) yielded" + "; xpu2xi-yielded-by-retain2context4xpu: " + str(xpu2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                    
    message2print = "{(Step 33/33) returning" + "; xpu2xi-returning-by-get2context4xpu: " + str(xpu2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4xpu-failed ; time: 04:14:11 05/21/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4xpu', 'METHOD': 'create2context4xpu'}, 'FUNCTION2CALLBACK': <function trace2context4xpu at 0x00000000037AE448>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:14:11 05/21/11 Pacific Daylight Time}
  
    
    return xpu2xi
            
#</function4xi> 
 
                                               
# =================================================================================================
#<class4xi class = "XPU2Context4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for XPU context" usage = "Context4Xi of XPU"
#>

# =================================================================================================
class XPU2Context4Xi(object): 
    ''' 
    XPU2Context4Xi offers  methods for XPU context
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2xpu = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'create2xpu',
    'get2xpu',
    'release2xpu',
    'retain2xpu',
    'set2xpu',
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-XPU2Context4Xi" usage = "
    # try:
    #     # ---------------------------------------------------------------------------------------------
    #     # CREATE OBJECT                        
    #     # ---------------------------------------------------------------------------------------------        
    #     cc2xi = XPU2Context4Xi()
    #     print('(Step 5B/33) OF XPU4XI5TEST - CREATED XPU2Context4Xi OBJECT: ', cc2xi)                                       
    # except:
    #     print('(Step 5Z/33) OF XPU4XI5TEST *** FAILED TO CREATE XPU2Context4Xi OBJECT')
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4create2xpu = None):
        '''
        _init__ method initializes XPU2Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "XPU2Context4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-XPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 

        message2print = "{(Step 1B/33) borning" + "; xpu2context2xi-of-XPU2Context4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-xpu2context2xi-of-XPU2Context4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2xpu-sharing-by-xpu2context2xi-of-XPU2Context4Xi: " + str(XPU2Context4Xi.classvariable2xpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                
                                
        message2print = "{(Step 1E/33) passed" + "; task4create2xpu-passed-to-init-of-XPU2Context4Xi: " + str(task4create2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                               
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4create2xpu-passing-to-create2context4xpu-by-init-of-XPU2Context4Xi: " + str(task4create2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
        
        xpu2context2xi = create2context4xpu(task4create2xpu)
        
        message2print = "{(Step 2B/33) performed" + "; create2context4xpu-performed-by-init-of-XPU2Context4Xi: " + str(create2context4xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; xpu2context2xi-of-XPU2Context4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-xpu2context2xi-of-XPU2Context4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2xpu-shared-by-xpu2context2xi-of-XPU2Context4Xi: " + str(XPU2Context4Xi.classvariable2xpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #               
       
        message2print = "{(Step 3D/33) returning" + "; init-of-XPU2Context4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create-of-XPU2Context4Xi" usage = "
    # print('(Step 1A/33) OF XPU2CONTEXT4XI - TRYING TO CREATE XPU CONTEXT')
    # try:
    #     cc2xi = XPU2Context4Xi()                            
    #     context2xpu = cc2xi.create2xpu()                                  
    #     print('(Step 1B/33) OF XPU4XI5TEST - SET XPU CONTEXT: ', context2xpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF XPU4XI5TEST *** FAILED TO SET XPU CONTEXT ***')
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2xpu(self, task4create2xpu = None):
        '''
        create2xpu method creates objects of XPU2Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "XPU2Context4Xi"
        method2print = "create2xpu"
                     
        message2print = "{(Step 1A/33) started" + "; create2xpu-of-XPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4create2xpu-passed-to-create2xpu-of-XPU2Context4Xi: " + str(task4create2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2xpu-passing-to-create2context4xpu-by-create2xpu-of-XPU2Context4Xi: " + str(task4create2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        xpu2context2xi = create2context4xpu(task4create2xpu)

        message2print = "{(Step 2B/33) performed" + "; create2context4xpu-performed-by-create2xpu-of-XPU2Context4Xi: " + str(create2context4xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; xpu2context2xi-returning-by-create2xpu-of-XPU2Context4Xi: " + str(xpu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
 
                
        return xpu2context2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2xpu-of-XPU2Context4Xi" usage = "
    # print('(Step 1A/33) OF XPU2CONTEXT4XI - TRYING TO SET XPU CONTEXT')
    # try:
    #     cc2xi = XPU2Context4Xi()                            
    #     context2xpu = cc2xi.set2xpu()                                  
    #     print('(Step 1B/33) OF XPU4XI5TEST - SET XPU CONTEXT: ', context2xpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF XPU4XI5TEST *** FAILED TO SET XPU CONTEXT ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2xpu(self, task4set2xpu = None):
        '''
        sets XPU2Context4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "XPU2Context4Xi"
        method2print = "set2xpu"
                     
        message2print = "{(Step 1A/33) started" + "; set2xpu-of-XPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4set2xpu-passed-to-set2xpu-of-XPU2Context4Xi: " + str(task4set2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2xpu-passing-to-set2context4xpu-by-set2xpu-of-XPU2Context4Xi: " + str(task4set2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        xpu2context2xi = set2context4xpu(task4set2xpu)

        message2print = "{(Step 2B/33) performed" + "; set2context4xpu-performed-by-set2xpu-of-XPU2Context4Xi: " + str(set2context4xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; xpu2context2xi-returning-by-set2xpu-of-XPU2Context4Xi: " + str(xpu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return xpu2context2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2xpu-of-XPU2Context4Xi" usage = "
    # print('(Step 1A/33) OF XPU2CONTEXT4XI - TRYING TO GET XPU CONTEXT')
    # try:
    #     cc2xi = XPU2Context4Xi()                            
    #     context2xpu = cc2xi.get2xpu()                                  
    #     print('(Step 1B/33) OF XPU4XI5TEST - GOT XPU CONTEXT: ', context2xpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF XPU4XI5TEST *** FAILED TO GET XPU CONTEXT ***')   
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2xpu(self):
        '''
        get2xpu method gets objects of XPU2Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "XPU2Context4Xi"
        method2print = "get2xpu"
                     
        message2print = "{(Step 1A/33) started" + "; get2xpu-of-XPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        xpu2context2xi = get2context4xpu()
        
        message2print = "{(Step 2A/33) returning" + "; xpu2context2xi-returning-by-get2xpu-of-XPU2Context4Xi: " + str(xpu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                
        return xpu2context2xi
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2xpu-of-XPU2Context4Xi" usage = "
    # print('(Step 1A/33) OF XPU2CONTEXT4XI - TRYING TO SET XPU CONTEXT')
    # try:
    #     cc2xi = XPU2Context4Xi()                            
    #     context2xpu = cc2xi.release2xpu()                                  
    #     print('(Step 1B/33) OF XPU4XI5TEST - SET XPU CONTEXT: ', context2xpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF XPU4XI5TEST *** FAILED TO SET XPU CONTEXT ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2xpu(self, task4release2xpu = None):
        '''
        releases XPU2Context4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "XPU2Context4Xi"
        method2print = "release2xpu"
                     
        message2print = "{(Step 1A/33) started" + "; release2xpu-of-XPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4release2xpu-passed-to-release2xpu-of-XPU2Context4Xi: " + str(task4release2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2xpu-passing-to-release2context4xpu-by-release2xpu-of-XPU2Context4Xi: " + str(task4release2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        xpu2context2xi = release2context4xpu(task4release2xpu)

        message2print = "{(Step 2B/33) performed" + "; release2context4xpu-performed-by-release2xpu-of-XPU2Context4Xi: " + str(release2context4xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; xpu2context2xi-returning-by-release2xpu-of-XPU2Context4Xi: " + str(xpu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return xpu2context2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2xpu-of-XPU2Context4Xi" usage = "
    # print('(Step 1A/33) OF XPU2CONTEXT4XI - TRYING TO SET XPU CONTEXT')
    # try:
    #     cc2xi = XPU2Context4Xi()                            
    #     context2xpu = cc2xi.retain2xpu()                                  
    #     print('(Step 1B/33) OF XPU4XI5TEST - SET XPU CONTEXT: ', context2xpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF XPU4XI5TEST *** FAILED TO SET XPU CONTEXT ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2xpu(self, task4retain2xpu = None):
        '''
        retains XPU2Context4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "XPU2Context4Xi"
        method2print = "retain2xpu"
                     
        message2print = "{(Step 1A/33) started" + "; retain2xpu-of-XPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2xpu-passed-to-retain2xpu-of-XPU2Context4Xi: " + str(task4retain2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2xpu-passing-to-retain2context4xpu-by-retain2xpu-of-XPU2Context4Xi: " + str(task4retain2xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        xpu2context2xi = retain2context4xpu(task4retain2xpu)

        message2print = "{(Step 2B/33) performed" + "; retain2context4xpu-performed-by-retain2xpu-of-XPU2Context4Xi: " + str(retain2context4xpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; xpu2context2xi-returning-by-retain2xpu-of-XPU2Context4Xi: " + str(xpu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return xpu2context2xi
                                                           
    #</methodize4xi>   
                                         
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-XPU2Context4Xi" usage = "
    # try:
    #     print(cc2xi.sense())
    # 
    #     print('=' *33)          
    #     print('(Step 15B/33) OF XPU4XI5TEST - SENSED ', time4xi())                                                  
    #                                                                                                                 
    #     print('=' *33)
    # except:
    #     print('(Step 15Z/33) OF XPU4XI5TEST *** FAILED TO SENSE ', time4xi())    
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses XPU2Context4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'XPU2Context4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-XPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; XPU2Context4Xi-sensing-by-sense-of-XPU2Context4Xi: " + str(XPU2Context4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-XPU2Context4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2xpu-of-XPU2Context4Xi'] = XPU2Context4Xi.classvariable2xpu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-XPU2Context4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; XPU2Context4Xi-sensed-by-sense-of-XPU2Context4Xi: " + str(XPU2Context4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-XPU2Context4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                    
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-XPU2Context4Xi" usage = "
    # try:
    #     print(cc2xi.reason())
    # 
    #     print('=' *33)          
    #     print('(Step 17B/33) OF XPU4XI5TEST - REASONED ', time4xi())                                                
    #     print('=' *33)       
    # except:
    #     print('(Step 17Z/33) OF XPU4XI5TEST *** FAILED TO REASON ', time4xi())     
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons XPU2Context4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'XPU2Context4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-XPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; XPU2Context4Xi-reasoning-by-reason-of-XPU2Context4Xi: " + str(XPU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-XPU2Context4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-XPU2Context4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-XPU2Context4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; XPU2Context4Xi-reasoned-by-reason-of-XPU2Context4Xi: " + str(XPU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-XPU2Context4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                     
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-XPU2Context4Xi" usage = "
    # try:
    #     print(cc2xi.ace())
    # 
    #     print('=' *33)          
    #     print('(Step 21B/33) OF XPU4XI5TEST - ACED ', time4xi())                                                    
    #     print('=' *33) 
    # except:
    #     print('(Step 21Z/33) OF XPU4XI5TEST *** FAILED TO ACE ', time4xi())      
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces XPU2Context4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'XPU2Context4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-XPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; XPU2Context4Xi-acing-by-ace-of-XPU2Context4Xi: " + str(XPU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-XPU2Context4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-XPU2Context4Xi'] = XPU2Context4Xi.classvariable2xpu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-XPU2Context4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; XPU2Context4Xi-aced-by-ace-of-XPU2Context4Xi: " + str(XPU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-XPU2Context4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   xpu2event4xi5test.txt
#   sense-xpu2event4xi5test.xml
#   reason-xpu2event4xi5test.xml
#   ace-xpu2event4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of xpu2context4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
